/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#include "inputs.h"
#include "outputs.h"
#include "stats.h"

#include "modem.h"
#include "typetools.h"

char inputbits[INPUT_MAX_DATA*8];

int bitspersymbol;



int process_modulate(int len)
{
    int i,j;
    unsigned short s;
    short *out_short=(short*) output_data;


    len*=8;

    bin2char(input_data,inputbits,len);

    j=0;
    for (i=0;i<len;i+=bitspersymbol) {
        ConvertBitsToSymbol(&inputbits[i],&s,bitspersymbol);
        Modulate(modulation,s,&out_short[j],&out_short[len/bitspersymbol+j]);
        if (i<100) {
            output_data_q[i]=out_short[len/bitspersymbol+j];
            output_data_i[i]=out_short[j];
        }
        j++;
    }
    return 4*j;
}

int process_demodulate(int len)
{
    int i,j;
    unsigned short s;
    short *in_short=(short*) input_data;

    len/=4;
/*
    if (modulation == MOD_QAM16) {
        ScaleSignalAmplitude(&input_data[2*len/bitspersymbol+j], Q_in, N_in, TARGET_SIGNAL_ENERGY);
    }
*/
    j=0;
    for (i=0;i<len;i++) {
        Demodulate(modulation,in_short[j],in_short[2*len/bitspersymbol+j],&s);
        ConvertSymbolToBits(s,&inputbits[j],bitspersymbol);
        j+=bitspersymbol;
        if (i<100) {
            output_data_i[i] = (char) inputbits[j];
        }
    }

    char2bin(inputbits,output_data,len);
    return typeSizeArray(TYPE_BITSTREAM,len);
}

int process_input(int len)
{
    int olen;

    bitspersymbol = getbitspersymbol(modulation);

    if (mode==MODULATE) {
        olen=process_modulate(len);
    } else {
        olen=process_demodulate(len);
    }
   
    SendItf(0,olen);

    return 1;
}

/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{
    return 1;
}

int InitCustom()
{
    return 1;
}

void ConfigInterfaces(){}



